<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 12rem;">
       
        <ReturnButton v-on:clickEvent="verifyEditModal" title="Ir a Segmentos" :offsetArrow="20" :spanTitle="3" class="text-end"></ReturnButton>
        <!-- Modal del btn de retroceso-->
        <AppModalReturn :show-dialog.sync="returnButtonModal" v-if="returnButtonModal" v-on:btnEvent="returnButtonModal = false" @btnEvent="viewListSegments" v-on:eventBtn="returnButtonModal = false">
        </AppModalReturn>
        <el-col :span="24" style="padding-top: 1.5rem">
          <el-card :body-style="{ padding: '10px' }" shadow="never" class="bg-form text-white title-views">Editar Segmento</el-card>
        </el-col>
      </el-header>
      <!-- FORMULARIO EDITAR SEGMENTO -->
      <el-main style="margin: 3rem 12.5rem">
        <el-form :rules="rules" ref="segment" :model="segment">
          <!-- titulo -->
          <h4 class="text-orange" style="margin-bottom:2rem">TÍTULO DEL SEGMENTO</h4>
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item label="Título:" prop="segmentTitle" class="inputTitle">
                <el-input v-model="segment.segmentTitle" size="small"></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin:2.5rem 0">


          <!-- PROGRAMA DEL SEGMENTO -->
          <h4 class="text-orange" style="margin-bottom:2rem">PROGRAMA DEL SEGMENTO</h4>
          <el-row style="margin-bottom: 20px;">
            <el-col :span="23" :offset="1">
              <el-form-item label="Código:" prop="codeProgram" class="inputTitle">
                <el-autocomplete
                    v-model="segment.codeProgram"
                    size="small"
                    :fetch-suggestions="querySearchCode"
                    :trigger-on-focus="false"
                    @select="handleSelectCode">
                  <template slot-scope="props">
                    <div>{{ props.item.codProgram }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>

          <el-row style="margin-bottom: 20px;">
            <el-col :span="23" :offset="1">
              <el-form-item label="Título:" prop="programTitle" class="inputTitle">
                <el-autocomplete
                  v-model="segment.programTitle"
                  style="width: 100%;"
                  size="small"
                  :fetch-suggestions="querySearch"
                  :trigger-on-focus="false"
                  @select="handleSelect">
                  <template slot-scope="props">
                    <div>{{ props.item.programTitle }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin:2.5rem 0">

          <!-- VIGENCIA DEL SEGMENTO -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">VIGENCIA</h4>
          <el-row type="flex" align="middle">
            <!-- INICIO DE VIGENCIA  -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].startValidity" label="Inicio:" class="selectInput">
                <el-date-picker
                  v-model="segment.validity[0].startValidity" type="date" placeholder="Seleccionar"
                  format="dd/MM/yyyy" size="small" @input="validateEndDate"> 
                </el-date-picker>       
              </el-form-item> 

              <!-- <el-form-item  prop="validityStart">
                <el-col :span="2">
                  <p class="font-general">Inicio:</p>
                </el-col>
                <el-col :span="11" style="margin-left:1.9rem">
                  <div>
                    <el-date-picker
                      v-model="startValidityValue" type="date" placeholder="Seleccionar"
                      format="dd/MM/yyyy"  size="small" @input="validateEndDate"> 
                    </el-date-picker>
                  </div>
                </el-col>          
              </el-form-item> -->
            </el-col>
            <!-- FIN DE VIGENCIA -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].endValidity" label="Fin:" class="selectInput">
                <el-date-picker
                  v-model="segment.validity[0].endValidity" type="date" placeholder="Seleccionar"
                  format="dd/MM/yyyy" size="small" :picker-options="datePickerOptions"> 
                </el-date-picker>        
              </el-form-item>

              <!-- <el-form-item  prop="validityEnd">
                <el-col :span="2">
                  <p class="font-general">Fin:</p>
                </el-col>
                <el-col :span="11" style="margin-left:1.1rem">
                  <div>
                    <el-date-picker
                      v-model="endValidityValue" type="date" placeholder="Seleccionar"
                      format="dd/MM/yyyy"  size="small" :picker-options="datePickerOptions"> 
                    </el-date-picker>
                  </div>
                </el-col>          
              </el-form-item> -->
            </el-col>
          </el-row>
          <hr style="margin:2.5rem 0">

          <!-- HORARIO DEL SEGMENTO -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">HORARIO DEL SEGMENTO</h4>
          <el-row style="margin-bottom:3rem">
            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Inicio:</span>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartHour" class="inputTitle">
                    <el-input size="small" v-model="segment.scheduleStartHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump4" @keyup.enter.native="$refs.jump1.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartMin" class="inputTitle">
                    <el-input size="small" v-model="segment.scheduleStartMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump1" @keyup.enter.native="$refs.jump2.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col>
              </el-row>
            </el-col>

            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Fin:</span>
                </el-col>
                <el-col :span="9" >
                  <el-form-item prop="scheduleEndHour" class="inputTitle">
                    <el-input size="small" v-model="segment.scheduleEndHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump2" @keyup.enter.native="$refs.jump3.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleEndMin" class="inputTitle">
                    <el-input size="small" v-model="segment.scheduleEndMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump3" @keyup.enter.native="$refs.jump4.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col>
              </el-row>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- DIAS DE TRANSMISION -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">DÍAS DE TRANSMISIÓN</h4>
          <el-row type="flex" align="middle">
            <el-col :span="23" :offset="1">
              <el-form-item prop="transmissionDays">
                <el-radio-group v-model="transmission" @change="weeksChange" style="margin-bottom:1.5rem">
                  <el-radio :label="3" style="margin-right: 1.7rem">Todos los días</el-radio>
                  <el-radio :label="6" style="margin-right: 1.7rem">Lunes a Viernes</el-radio>
                  <el-radio :label="9" style="margin-right: 1.7rem">Sábados y Domingos</el-radio>
                </el-radio-group>
                <el-checkbox-group v-model="segment.transmissionDays" @change="handleCheckedDaysChange">
                  <el-checkbox-button v-for="day in days" :label="day" :key="day">{{day}}</el-checkbox-button>
                </el-checkbox-group>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- SEÑALES -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">SEÑALES</h4>
          <el-row style="margin: 0.7rem 0 1rem">          
            <el-col :span="6">
              <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange" border>Todas las señales</el-checkbox>
            </el-col>
            <el-col :span="6"><el-button @click="signalModal = true">Seleccionar</el-button></el-col>

            <!-- Modal -->
            <el-dialog
              :visible.sync="signalModal"
              width="40%"
              center
              :close-on-press-escape="false"
              custom-class="dialog-orange">
              <el-form-item style="margin: 0" prop="checkedSignals">
                <el-checkbox-group v-model="segment.checkedSignals" @change="handleCheckedSignalsChange" class="text-center" style="margin-left: 3rem;">
                  <el-checkbox  v-for="signal in signals" :label="signal" :key="signal" style="width: 30%; margin: 0" class="text-start">{{signal}}</el-checkbox>
                </el-checkbox-group>              
              </el-form-item>
              <span slot="footer">
                <el-button v-on:click="updatingSignals" @click="signalModal = false" class="border-orange text-orange" style="margin: 0 16rem 1rem 0">Aceptar</el-button>
              </span>
            </el-dialog>            
          </el-row>
          <el-form-item style="margin: 0" prop="checkedSignals">
            <div class="bg-gray" style="display: table; height: 8rem; width:100%; padding: 10px 7px 7px">
              <el-col v-for="(item, j) in segment.checkedSignals" :key="j" 
                class="bg-white" style="margin:7px; padding:0 5px; width:8rem">{{item}} </el-col>
            </div>
          </el-form-item>
          <!-- boton actualizar -->
          <div style="margin-top:4rem" class="text-end">
            <!-- <el-button @click="updatedSegment" type="primary">ACTUALIZAR</el-button> -->
            <el-button @click="submitForm('segment')" type="primary">ACTUALIZAR</el-button>
          </div>

          <!-- MODAL DE FORMULARIO INVALIDO -->
          <AppModal :show-dialog.sync="invalidForm" v-if="invalidForm" nameClass="dialog-red" 
            :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  
            :parrafo="'Por favor, ingrese todos los campos requeridos.'">
          </AppModal>
        </el-form>
      </el-main>
    </div>
  </div>
</template>

<script>

import ReturnButton from '@/components/ReturnButton.vue'
import AppModalReturn from '@/components/AppModalReturn.vue'
import { validateTime } from '@/utils/calculateTime.js'
import AppModal from '@/components/AppModal.vue'
import { HTTP } from '../../main.js'

const allWeek = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado", "Domingo"];
const week = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes"];
const weekend = ["Sábado", "Domingo"];

String.prototype.toProperCase = function () {
  const re = /(^|[^A-Za-zÁÉÍÓÚÜÑáéíóúüñ])(?:([a-záéíóúüñ])|([A-ZÁÉÍÓÚÜÑ]))|([A-ZÁÉÍÓÚÜÑ]+)/gu;
  return this.replace(re,
    (m, caracterPrevio, minuscInicial, mayuscInicial, mayuscIntermedias) => {
      const locale = ['es', 'gl', 'ca', 'pt', 'en'];
      if (mayuscIntermedias)
        return mayuscIntermedias.toLocaleLowerCase(locale);
      return caracterPrevio
        + (minuscInicial ? minuscInicial.toLocaleUpperCase(locale) : mayuscInicial);
    });
};

export default {
  components: {
    ReturnButton,
    AppModalReturn,
    AppModal
  },
  data () {
    return {     
      // segment:{
      //   checkedSignals: [],
      // },
      segment: {
        segmentTitle: "",
        codeProgram: "",
        programTitle: "",
        segmentClassification: "",
        segmentDescription:"",
        transmissionDays: [],
        transmissionDaysDescription: [],
        checkedSignals: [],
        scheduleStartHour:"",
        scheduleStartMin:"",
        scheduleEndHour:"",
        scheduleEndMin:"",
        validity: [
          { startValidity: '',
            endValidity: ''   }
        ],
      },
      rules: {
        segmentTitle: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        codeProgram: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        programTitle: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        validity: [
          { 
            startValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }],
            endValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }]
          }
        ],
        segmentClassification: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        segmentDescription: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleStartHour: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleStartMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndHour: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        transmissionDays: [
          { required: true, message: 'Por favor seleccione los días de transmisión', trigger: 'change' },
        ],
        checkedSignals: [
          { required: true, message: 'Por favor seleccione las señales', trigger: 'change' },
        ]
      },
      signalsTable: [], //Desde DB - Señales
      classifTable: [], //Desde DB
      segmentTypeTable: [],
      idEdit: JSON.parse(this.$localStorage.get('segmentId')),
      transmission: [],
      days: allWeek,
      weekend: weekend,
      laboralDays: week,
      isIndeterminate: false,
      checkAll: true,
      signalModal: false,
      addSegmentModal: false,
      returnButtonModal: false,
      datePickerOptions: {
        disabledDate: this.disabledValidityDate
      },
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      links: [],
      programTitle: "",
      codeProgram: "",
      contador: 0,
      codigoDias: [],
      numberWeek: [2, 3, 4, 5, 6, 7, 1],
      signalsByCode: '',
      arrSignalsCode: [],
      invalidForm: ''
    };
  },
  computed: {
    verifyChangeModal () {
      if (this.segment.segmentTitle) {
        const array = [
          this.segment.segmentTitle,
          this.segment.segmentClassification,
          this.segment.segmentDescription,
          this.segment.transmissionDays.length,
          this.segment.transmissionDaysDescription.length,
          this.segment.checkedSignals.length,
          this.segment.scheduleStartHour,
          this.segment.scheduleStartMin,
          this.segment.scheduleEndHour, 
          this.segment.scheduleEndMin,
          this.segment.validity[0].startValidity,
          this.segment.validity[0].endValidity,
          this.programTitle,
          this.codeProgram 
        ].join()
          return array
      }
    },
    signals: function () {
      let dataTables = this.$store.state.tables;
      for (let i = 0; i < dataTables.length; i++) {
        if (dataTables[i].tableName === 'allSignals') {
          this.signalsTable = dataTables[i].types
          this.signalsByCode = dataTables[i].description
          return dataTables[i].types
        }
      }
    }
  },
  created () {
    this.fetchSegment()
    this.getTables ()
    this.getProgram()
    this.gettingUsername()
  },
  methods: {
    gettingUsername(){
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    verifyEditModal () {
      if(this.contador > 1) {
        this.returnButtonModal = true
      }
      else {
        this.$router.push({name: 'segments'})
      }
    },
    getProgram () {
      HTTP.get('programs')
      .then(res => {
        this.links = res.data.programs;  
        console.log(this.links, 'this.links') 
      })
      .catch(err => {
        console.log(err);
      });
    },
     querySearch(queryString, cb) {
      var links = this.links;
      var results = queryString ? links.filter(this.createFilter(queryString)) : links;
      console.log(results, 'results')
      cb(results);
    },
    createFilter(queryString) {
      return (link) => {
        return (link.programTitle.toLowerCase().indexOf(queryString.toLowerCase()) !== -1);
      };
    },
    handleSelect(item) {
    console.log(item);
    this.segment.programTitle = item.programTitle
    this.segment.codeProgram = item.codProgram
    
    },
    querySearchCode(queryString, cb) {
      var links = this.links;
      var results = queryString ? links.filter(this.createFilterCode(queryString)) : links;
      console.log(results, 'results')
      cb(results);
    },
    createFilterCode(queryString) {
      return (link) => {
        return (link.codProgram.toLowerCase().indexOf(queryString.toLowerCase()) !== -1);
      };
    },
    handleSelectCode(item) {
      console.log(item);
      this.segment.programTitle = item.programTitle
      this.segment.codeProgram = item.codProgram 
    },
    getTables () {
      let dataType = 'tables';
      this.$store.dispatch("getData", dataType);
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }      
    },
    disabledValidityDate (time) {
        return time.getTime() < this.segment.validity[0].startValidity
    },
    validateEndDate () {
      if (this.segment.validity[0].startValidity > this.segment.validity[0].endValidity) {
        this.segment.validity[0].endValidity = this.segment.validity[0].startValidity
      } 
    },
    weeksChange (val) {
      let arrCode = []
      let arrIndexCode
      if (this.transmission === 3) {
        this.segment.transmissionDays = val ? allWeek : [];
        arrIndexCode = this.arrayDiasCode(allWeek)
      } else if (this.transmission === 6) {
        this.segment.transmissionDays = val ? week : [];
        arrIndexCode = this.arrayDiasCode(week)
      } else if (this.transmission === 9) {
        this.segment.transmissionDays = val ? weekend : [];
        arrIndexCode = this.arrayDiasCode(weekend)
      }

      for(let r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")
    },
    handleCheckedDaysChange (value) {
      if (value.length === 7) {
        this.transmission = 3
      } else if (value.sort().join() == weekend.sort().join()) {
        this.transmission = 9
      } else  if (value.sort().join() == week.sort().join()) {
        this.transmission = 6
      } else {
        this.transmission = []
      }

      let arrCode = []
      let arrIndexCode = this.arrayDiasCode(value)
      for(let r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")
    },
    fetchSegment () {
      const segmentId = JSON.parse(this.$localStorage.get('segmentId'));
        HTTP.get('segments/' + segmentId)
        .then(res => {
          this.segment = res.data.segment;
          // DATE OF START VALIDITY
          let startValidity = this.segment.validity[0].startValidity.split("/")
          let newStartValidity = startValidity[1]+'/'+startValidity[0]+'/'+startValidity[2]
          this.segment.validity[0].startValidity = new Date(newStartValidity).getTime()
          // DATE OF END VALIDITY
          let endValidity = this.segment.validity[0].endValidity.split("/")
          let newEndValidity = endValidity[1]+'/'+endValidity[0]+'/'+endValidity[2]
          this.segment.validity[0].endValidity = new Date(newEndValidity).getTime()

          this.codigoDias = res.data.segment.codeDays
          this.arrSignalsCode = res.data.segment.signalsCode
          this.handleCheckedDaysChange(this.segment.transmissionDays)
        })
        .catch(err => console.log(err))
    },
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.updatedSegment()
        } else {
          this.invalidForm = true
          return false;
        }
      });
    },
    updatedSegment () {
      let transmissionDaysToFilter = this.segment.transmissionDays;
      let missingDays = this.days.filter(function(obj) { return transmissionDaysToFilter.indexOf(obj) == -1; });
      let daysLeftover = this.days.filter(function(obj) { return missingDays.indexOf(obj) == -1; });
      this.segment.transmissionDays = daysLeftover;

      if (this.segment.scheduleStartHour.length === 1) {
        this.segment.scheduleStartHour = "0" + this.segment.scheduleStartHour;
      }
      if (this.segment.scheduleStartMin.length === 1) {
        this.segment.scheduleStartMin = "0" + this.segment.scheduleStartMin;
      }
      if (this.segment.scheduleEndHour.length === 1) {
        this.segment.scheduleEndHour = "0" + this.segment.scheduleEndHour;
      }
      if (this.segment.scheduleEndMin.length === 1) {
        this.segment.scheduleEndMin = "0" + this.segment.scheduleEndMin;
      }
      if(this.segment.transmissionDays.join() != this.laboralDays.join() && this.segment.transmissionDays.length !== 7) {
        let description = this.segment.transmissionDays.join(', ');
        this.segment.transmissionDaysDescription = description.replace(/,(?=[^,]*$)/, ' y');
      }
      if(this.segment.transmissionDays.join() == this.weekend.join()) {
        this.segment.transmissionDaysDescription = 'Sábados y domingos'
      }
      if(this.segment.transmissionDays.length === 7){
        this.segment.transmissionDaysDescription = 'Todos los dias'
      } 
      if(this.segment.transmissionDays.join() == this.laboralDays.join()){
        this.segment.transmissionDaysDescription = 'De Lunes a Viernes'
      } 
      
      let startValidity = new Date(this.segment.validity[0].startValidity).toLocaleDateString('en-GB')
      let endValidity = new Date(this.segment.validity[0].endValidity).toLocaleDateString('en-GB')
      // this.validity[0].startValidity = this.startValidityValue.toLocaleDateString('en-GB')
      // this.validity[0].endValidity = this.endValidityValue.toLocaleDateString('en-GB')
      let hoursInicio = this.convertHourDate(this.segment.validity[0].startValidity, this.segment.scheduleStartHour, this.segment.scheduleStartMin)
      let hoursFin = this.convertHourDate(this.segment.validity[0].endValidity, this.segment.scheduleEndHour, this.segment.scheduleEndMin)
      this.segment.validity[0].startValidity = startValidity
      this.segment.validity[0].endValidity = endValidity
      
      HTTP.patch('segments/' + this.idEdit,
        [
          { propName: "segmentTitle", value: this.segment.segmentTitle.toProperCase() },
          { propName: "segmentType", value: this.segment.segmentType}, 
          { propName: "transmissionDays", value: this.segment.transmissionDays}, 
          { propName: "transmissionDaysDescription", value: this.segment.transmissionDaysDescription}, 
          { propName: "checkedSignals", value: this.segment.checkedSignals}, 
          { propName: "scheduleStartHour", value: this.segment.scheduleStartHour}, 
          { propName: "scheduleStartMin", value: this.segment.scheduleStartMin}, 
          { propName: "scheduleEndHour", value: this.segment.scheduleEndHour}, 
          { propName: "scheduleEndMin", value: this.segment.scheduleEndMin}, 
          { propName: "validity", value: this.segment.validity}, //this.validity
          { propName: "userName", value: this.userName},
          { propName: "userEmail", value: this.userEmail},
          { propName: "codSegment", value: this.segment.codSegment},
          { propName: "programTitle", value: this.segment.programTitle },
          { propName: "codeProgram", value: this.segment.codeProgram },
          { propName: "codeDays", value: this.codigoDias},
          { propName: "geminisCode", value: this.segment.geminisCode},
          { propName: "signalsCode", value: this.arrSignalsCode},
          { propName: "vigencia", value: [{
            startValidity: hoursInicio,
            endValidity: hoursFin,
            hourStart: hoursInicio,
            hoursEnd: hoursFin
          }]}
        ])
        .then(res => {
          let dataType = "segments"
          this.$store.dispatch("getData", dataType)
          this.$router.push({name: 'segments'});
        })
        .catch(err => {
        })
    },
    convertHourDate (date, hours, minutes) {
      var d = new Date(date).toLocaleDateString('en-GB')
      var newString = d + ' ' + hours + ':' + minutes + ':' + '00'
      console.log(newString)
      return newString
    },
    handleCheckAllChange (val) {
      this.segment.checkedSignals = val ? this.signalsTable : [];
      this.isIndeterminate = false;

      let arrCode = []
      let arrIndexCode = this.arraySignalCode(this.signalsTable)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
      console.log(this.arrSignalsCode, "arrSignalsCode")
    },
    updatingSignals () {     
      let checkboxes = document.querySelectorAll(
        "input[type=checkbox]:checked"
      );
      let checkArrValue = [];
      for (var i = 0; i < checkboxes.length; i++) {
        checkArrValue.push(checkboxes[i].value);
      }
      let segmentEdit = this.segment.checkedSignals;
      let daysEdit = this.days;
      var array3 = checkArrValue.filter(function(obj) { return segmentEdit.indexOf(obj) == -1; });
      var array4 = array3.filter(function(obj) { return daysEdit.indexOf(obj) == -1; });
      array4.map((el,i) => {
        this.segment.checkedSignals.push(el);
      })
      console.log(this.segment.checkedSignals);
    },
    arraySignalCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.signals.length; y++){
          if(this.signals[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    handleCheckedSignalsChange (value) {
      let checkedCount = value.length;
      this.checkAll = checkedCount === this.signals.length;
      let arrCode = []

      let arrIndexCode = this.arraySignalCode(value)
      for(let r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
      console.log(this.arrSignalsCode, "arrSignalsCode")
      this.isIndeterminate = checkedCount > 0 && checkedCount < this.signals.length;
    },
    cleanAllInputs (segment) {
      this.$refs[segment].resetFields()
      this.transmission = [];
      this.isIndeterminate = true
    },
    viewListSegments () {
      this.$router.push({name: 'segments'})
    },
    convertHourDate (date, hours, minutes) {
      var d = new Date(date).toLocaleDateString('en-GB')
      var newString = d + ' ' + hours + ':' + minutes + ':' + '00'
      console.log(newString)
      return newString
    },
    arrayDiasCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.days.length; y++){
          if(this.days[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
  },
  watch: {
    verifyChangeModal(val) {
      this.contador += 1
    },
    'segment.scheduleStartHour'(val) {
      this.segment.scheduleStartHour = validateTime(val, 23)
    },
    'segment.scheduleStartMin'(val) {
      this.segment.scheduleStartMin = validateTime(val, 59)
    },
    'segment.scheduleEndHour'(val) {
      this.segment.scheduleEndHour = validateTime(val, 23)
    },
    'segment.scheduleEndMin'(val) {
      this.segment.scheduleEndMin = validateTime(val, 59)
    },
  }
}
</script>

